# opentl::output::Output Class Reference

List of all members.

## Public Member Functions
| Output ()
| Constructor.
virtual | ~Output ()
| Destructor.
## Static Public Member Functions
static void | drawBoundingBox (opentl::core::cvdata::Image *Image, opentl::core::cvdata::Image *blobmap)
static void | drawBoxedTextAt (std::string text, opentl::core::cvdata::Image *image, CvPoint position, double scale=.5, int padding=3, int thickness=1, CvScalar boxColor=CV_RGB(138, 73, 55), CvScalar textColor=CV_RGB(255, 255, 255), CvScalar borderColor=CV_RGB(175, 175, 175))
static void | drawCrossHair (opentl::core::cvdata::Image &img, opentl::modelprojection::Warp &warp, opentl::core::cvdata::Pose &pose, int thickness=1, CvScalar color=CV_RGB(255, 255, 255), int camIdx=0)
static void | drawFrame3d (opentl::core::cvdata::Image &improc, opentl::core::State &state, math::Vector3 &origin, opentl::input::ImageSensor &mWorld)
static void | drawPose (opentl::core::cvdata::Image &img, opentl::core::cvdata::CvData &visFeat, opentl::modelprojection::Warp &warp, opentl::core::cvdata::Pose &pose, int thickness=1, CvScalar color=cvScalarAll(255.0), bool drawEdgeNormals=false, bool drawEdges=true, bool drawNonFeatures=false, int camIdx=0)
| Function which is able to draw different type of visual features based on warp function.
static void | drawPose (const models::Target &target, opentl::core::cvdata::Image &img, opentl::modelprojection::Warp &warp, int thickness=1, CvScalar color=cvScalarAll(255.0), bool drawEdgeNormals=false, bool drawEdges=true, bool drawNonFeatures=false, int camIdx=0)
| Function which is able to draw a target using it's outputstate.
static void | drawTextAt (std::string text, opentl::core::cvdata::Image *image, CvPoint position, const CvScalar color=CV_RGB(200, 150, 150), const float size=1.0, const int thickness=1)
static std::string | str (double val, int precision=3)

## Constructor & Destructor Documentation

opentl::output::Output::Output | ( |  | ) | `[inline]`

Constructor.

virtual opentl::output::Output::~Output | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

static void opentl::output::Output::drawBoundingBox | ( | opentl::core::cvdata::Image * | Image,
|  | opentl::core::cvdata::Image * | blobmap |
| ) |  |  | `[static]`

static void opentl::output::Output::drawBoxedTextAt | ( | std::string | text,
|  | opentl::core::cvdata::Image * | image,
|  | CvPoint | position,
|  | double | scale = `.5`,
|  | int | padding = `3`,
|  | int | thickness = `1`,
|  | CvScalar | boxColor = `CV_RGB(138, 73, 55)`,
|  | CvScalar | textColor = `CV_RGB(255, 255, 255)`,
|  | CvScalar | borderColor = `CV_RGB(175, 175, 175)` |
| ) |  |  | `[static]`

colors is font-color, box-color and border-color

static void opentl::output::Output::drawCrossHair | ( | opentl::core::cvdata::Image & | img,
|  | opentl::modelprojection::Warp & | warp,
|  | opentl::core::cvdata::Pose & | pose,
|  | int | thickness = `1`,
|  | CvScalar | color = `CV_RGB(255, 255, 255)`,
|  | int | camIdx = `0` |
| ) |  |  | `[static]`

static void opentl::output::Output::drawFrame3d | ( | opentl::core::cvdata::Image & | improc,
|  | opentl::core::State & | state,
|  | math::Vector3 & | origin,
|  | opentl::input::ImageSensor & | mWorld |
| ) |  |  | `[static]`

static void opentl::output::Output::drawPose | ( | opentl::core::cvdata::Image & | img,
|  | opentl::core::cvdata::CvData & | visFeat,
|  | opentl::modelprojection::Warp & | warp,
|  | opentl::core::cvdata::Pose & | pose,
|  | int | thickness = `1`,
|  | CvScalar | color = `cvScalarAll(255.0)`,
|  | bool | drawEdgeNormals = `false`,
|  | bool | drawEdges = `true`,
|  | bool | drawNonFeatures = `false`,
|  | int | camIdx = `0` |
| ) |  |  | `[static]`

Function which is able to draw different type of visual features based on warp function.

Parameters:

  | img | Pointer to output image.
  | visFeat | The visual features to draw, e.g. ShapeAppearance, VisContourSamplePts, ..
  | warp | Pointer to warp instance. (execute warpUpdate() first for a certain pose)
  | pose | Pointer to pose instance you want to draw
  | thickness | Line or point thickness in pixel
  | color | Line color
  | drawEdgeNormals | Switch to draw also the edge normals
  | drawEdges | Switch to draw edges
  | camIdx | draw pose in camera space with camera index camIdx

static void opentl::output::Output::drawPose | ( | const models::Target & | target,
|  | opentl::core::cvdata::Image & | img,
|  | opentl::modelprojection::Warp & | warp,
|  | int | thickness = `1`,
|  | CvScalar | color = `cvScalarAll(255.0)`,
|  | bool | drawEdgeNormals = `false`,
|  | bool | drawEdges = `true`,
|  | bool | drawNonFeatures = `false`,
|  | int | camIdx = `0` |
| ) |  |  | `[static]`

Function which is able to draw a target using it's outputstate.

Parameters:

  | target | The target to draw
  | img | Pointer to output image.
  | warp | Pointer to warp instance. (execute warpUpdate() first for a certain pose)
  | thickness | Line or point thickness in pixel
  | color | Line color
  | drawEdgeNormals | Switch to draw also the edge normals
  | drawEdges | Switch to draw edges
  | camIdx | draw pose in camera space with camera index camIdx

static void opentl::output::Output::drawTextAt | ( | std::string | text,
|  | opentl::core::cvdata::Image * | image,
|  | CvPoint | position,
|  | const CvScalar | color = `CV_RGB(200, 150, 150)`,
|  | const float | size = `1.0`,
|  | const int | thickness = `1` |
| ) |  |  | `[static]`

static std::string opentl::output::Output::str | ( | double | val,
|  | int | precision = `3` |
| ) |  |  | `[inline, static]`